#include <exec/types.h>
#include <intuition/classes.h>
#include <intuition/classusr.h>
#include <utility/hooks.h>

#include <emul/emulinterface.h>
#include <emul/emulregs.h>

#include <public/proto/quark/syscall_protos.h>

#define	DEBUG_DOMETHOD(x)	;
#define	DEBUG_DOSUPERMETHOD(x)	;
#define	DEBUG_COERCEMETHOD(x)	;

ULONG	CallHookA(struct Hook	*MyHook,
                  Object	*MyObject,
		  APTR		MyMsg)
{
struct EmulCaos	MyCaos;

  MyCaos.caos_Un.Function	=(void*) MyHook->h_Entry;
  MyCaos.reg_a0			=(ULONG) MyHook;
  MyCaos.reg_a1			=(ULONG) MyMsg;
  MyCaos.reg_a2			=(ULONG) MyObject;
  return((*MyEmulHandle->EmulCall68k)(&MyCaos));
}

ULONG	DoMethodA(Object	*MyObject,
                  Msg		MyMsg)
{
Class		*MyClass;
struct EmulCaos	MyCaos;

  DEBUG_DOMETHOD(dprintf("DoMethod: Object 0x%lx Msg 0x%lx\n",
                         MyObject,
                         MyMsg));

  if (MyObject)
  {
    MyClass	=(struct IClass*) (((ULONG*) MyObject)[-1]);

    MyCaos.caos_Un.Function	=(void*) MyClass->cl_Dispatcher.h_Entry;
    MyCaos.reg_a0		=(ULONG) MyClass;
    MyCaos.reg_a1		=(ULONG) MyMsg;
    MyCaos.reg_a2		=(ULONG) MyObject;
    return((*MyEmulHandle->EmulCall68k)(&MyCaos));
  }
  else
  {
    return(0);
  }
}

ULONG	DoSuperMethodA(Class		*MyClass,
                       Object		*MyObject,
                       Msg		MyMsg)
{
struct EmulCaos	MyCaos;

  DEBUG_DOSUPERMETHOD(dprintf("DoSuperMethod: Class 0x%lx Object 0x%lx Msg 0x%lx\n",
                              MyClass,
                              MyObject,
                              MyMsg));

  if (MyClass && MyObject)
  {
    MyCaos.caos_Un.Function	=(void*) MyClass->cl_Super->cl_Dispatcher.h_Entry;
    MyCaos.reg_a0		=(ULONG) MyClass->cl_Super;
    MyCaos.reg_a1		=(ULONG) MyMsg;
    MyCaos.reg_a2		=(ULONG) MyObject;
    return((*MyEmulHandle->EmulCall68k)(&MyCaos));
  }
  else
  {
    return(0);
  }
}

ULONG	CoerceMethodA(Class		*MyClass,
                      Object		*MyObject,
                      Msg		MyMsg)
{
struct EmulCaos	MyCaos;

  DEBUG_COERCEMETHOD(dprintf("CoerceMethod: Class 0x%lx Object 0x%lx Msg 0x%lx\n",
                             MyClass,
                             MyObject,
                             MyMsg));

  if (MyClass && MyObject)
  {
    MyCaos.caos_Un.Function	=(void*) MyClass->cl_Dispatcher.h_Entry;
    MyCaos.reg_a0		=(ULONG) MyClass;
    MyCaos.reg_a1		=(ULONG) MyMsg;
    MyCaos.reg_a2		=(ULONG) MyObject;
    return((*MyEmulHandle->EmulCall68k)(&MyCaos));
  }
  else
  {
    return(0);
  }
}
