#ifndef	QUARK_QUARK_H
#define	QUARK_QUARK_H

#include <public/quark/types.h>
#include <public/quark/id.h>

#define QQUARK_DUMMY		(0x0)

/* Sequence: QQUARKTAG_TID, char *Name
 * Function: Get
 *           Get the TID with the specified name
 */
#define	QQUARKTAG_TID			(QQUARK_DUMMY + 0x1)

/* Sequence: QQUARKTAG_EXCEPTIONTID
 * Function: Get
 * Get the next ExceptionTID or ID_NULL if no
 * further exception threads are found.
 * When it finds a thread which has a pending
 * exception it adds them to the Wait list with
 * a SigWait mask of 0.
 * So your exception thread can wake it up again
 * by QSignal(MyExceptionThread,0);
 * Only useful for global exception handlers to
 * get the threads from the exception fifo.
 */
#define	QQUARKTAG_GETEXCEPTIONTHREAD	(QQUARK_DUMMY + 0x2)

/* Sequence: QQUARKTAG_EXCEPTIONHANDLER, q_tid_t
 * Function: Get/Set
 *           Get/Set the global exceptionhandler
 */
#define	QQUARKTAG_EXCEPTIONHANDLER	(QQUARK_DUMMY + 0x3)

#endif
